#include "stm32f10x.h"

//hardware

void init_stm(void);
void init_spi1(void);
void init_tim(void);

//interrupts

void TIM3_IRQHandler(void);

//------------------------------------

void init_TLC(void);
void set_DC(u16 *DC);
void convertData(u8 *Din);






//--------------------------------------------------

#define TLC_N		1
#define dataIN_N		(TLC_N*16)
#define GSdata_N		(TLC_N*192/16)
#define DCdata_N		(TLC_N*92/16)


#define VPRG_1		GPIOA->BSRR = GPIO_BSRR_BS2
#define VPRG_0		GPIOA->BSRR = GPIO_BSRR_BR2

#define DCPRG_1		GPIOA->BSRR = GPIO_BSRR_BS3
#define DCPRG_0		GPIOA->BSRR = GPIO_BSRR_BR3

#define BLANK_1		GPIOA->BSRR = GPIO_BSRR_BS4
#define BLANK_0		GPIOA->BSRR = GPIO_BSRR_BR4

#define XLAT_1		GPIOB->BSRR = GPIO_BSRR_BS11
#define XLAT_0		GPIOB->BSRR = GPIO_BSRR_BR11







u32 i = 0;

//flags

volatile u8 latchData = 0;
volatile u8 nextData = 0;
u8 fstCycleFlag = 0;

///////////////////////////

u8 DataIn[dataIN_N];//B R G;		   8-bit gray scale data from glediator

u16 GSdataOut[GSdata_N];// GGGB,BBRR,RGGG   16-bit gray scale data

u16 DCdataOut[DCdata_N];			// 16-bit dot correction data





//main

int main(void){
    //po maximumu
	for(i=0;i<DCdata_N;i++){
		DCdataOut[i] = 0xFFFF;
	}
    
	for(i=0;i<GSdata_N;i++){
		GSdataOut[i] = 0xFFFF;
	}
    
	init_stm();
	set_DC(DCdataOut);
    
	BLANK_0;
    
    
	while(1){
        
		//if there is new data... then convert 8bit to 12bit-in-16bit
        
		if(newData==1){
			convertData(DataIn); //convert  array
			newData = 0;
		}
        
		//send next data to TLC's
        
		if(nextData==1){
			if(fstCycleFlag ==1){
				SPI1->CR1 	&= 	~SPI_CR1_SPE;	//disable SPI
				GPIOA->CRL 	&= 	~GPIO_CRL_CNF5;		//now PA5  PP mode
                
				GPIOA->BSRR = 	GPIO_BSRR_BS5;		//"SCLK" HI
				GPIOA->BSRR = 	GPIO_BSRR_BR5;		//"SCLK" LO
				GPIOA->CRL 	|=  GPIO_CRL_CNF5_1;	//now PA5 is Alternate SCLK
				SPI1->CR1 	|= 	SPI_CR1_SPE;			//enable SPI
                
			}
            
			//send out gray scale data
            
			while (!(SPI1->SR & SPI_SR_TXE));
			for(i=0;i< GSdata_N;i++){
				SPI1->DR = GSdataOut[i];
				while (!(SPI1->SR & SPI_SR_TXE));
			}
            
			fstCycleFlag = 1;
            
			latchData = 1;//now we can latch this data (puls of XLAT when BLANK pulse is present)
			nextData = 0;
		}
	}
}

//-------------------------------------------

void init_stm(void){
    
	//peripherals----------------------------------------------------------------------
    
	RCC->APB2ENR |= (RCC_APB2ENR_IOPAEN |	RCC_APB2ENR_AFIOEN);
    
	RCC->APB2ENR |= (RCC_APB2ENR_IOPBEN);
    
	//A
    
	GPIOB->CRL |= GPIO_CRL_MODE0;//ћаксимальна€ скорость порта = 50 MHz
    
	GPIOB->CRL &= ~GPIO_CRL_CNF0;//
    
	//B
    
	GPIOB->CRL |= GPIO_CRL_MODE1;//ћаксимальна€ скорость порта = 50 MHz
    
	GPIOB->CRL &= ~GPIO_CRL_CNF1;//
    
	//C
    
	GPIOB->CRL |= GPIO_CRL_MODE2;//ћаксимальна€ скорость порта = 50 MHz
    
	GPIOB->CRL &= ~GPIO_CRL_CNF2;//
    
	//LED
    
	GPIOB->CRH |= GPIO_CRH_MODE9;//ћаксимальна€ скорость порта = 50 MHz
    
	GPIOB->CRH &= ~GPIO_CRH_CNF9;//
    
	//GPIOB->BSRR = GPIO_BSRR_BS9;
    
	//VPRG  PA2
    
	GPIOA->CRL |= GPIO_CRL_MODE2;//ћаксимальна€ скорость порта = 50 MHz
    
	GPIOA->CRL &= ~GPIO_CRL_CNF2;//
    
	//DCPRG  PA3
    
	GPIOA->CRL |= GPIO_CRL_MODE3;//ћаксимальна€ скорость порта = 50 MHz
    
	GPIOA->CRL &= ~GPIO_CRL_CNF3;//
    
	//BLANK  PA4
    
	GPIOA->CRL |= GPIO_CRL_MODE4;//ћаксимальна€ скорость порта = 50 MHz
    
	GPIOA->CRL &= ~GPIO_CRL_CNF4;//
    
	//XLAT  PB11
    
	GPIOB->CRH |= GPIO_CRH_MODE11;//ћаксимальна€ скорость порта = 50 MHz
    
	GPIOB->CRH &= ~GPIO_CRH_CNF11;//
    
    
    
	XLAT_0;
    
	BLANK_1;
    
	VPRG_0;
    
	DCPRG_0;
    
    //GSCLK GSCLK GSCLK GSCLK GSCLK GSCLK
    
	GPIOA->CRH	&= ~GPIO_CRH_CNF8;		// —брасываем биты CNF дл€ бита 8. –ежим 00 - Push-Pull
    
	GPIOA->CRH	|= GPIO_CRH_CNF8_1;		// —тавим режим дл€ 8 го бита режим CNF  = 10 (альтернативна€ функци€, Push-Pull)
    
    
    
	GPIOA->CRH	&=~GPIO_CRH_MODE8;				// —брасываем биты MODE дл€ бита 8
    
	GPIOA->CRH	|= GPIO_CRH_MODE8_1 | GPIO_CRH_MODE8_0;	// ¬ыставл€ем бит MODE дл€ п€того пина. –ежим MODE11 = Max Speed 50MHz
    
    
    
	RCC->CFGR	&=~(RCC_CFGR_MCO);		// ќбнул€ем MCO
    
	RCC->CFGR	|=RCC_CFGR_MCO_PLL;		// ¬ыставлем дл€ MCO сигнал с PLL/2
    
	//RCC->CFGR	|=RCC_CFGR_MCO_SYSCLK;		// ¬ыставл€ем дл€ ћ—ќ сигнал с SYSCLK
    
    //END GSCLK END GSCLK END GSCLK END GSCLK
    
	init_tim();
	
    
	__enable_irq();
    
	init_spi1();
    
	init_TLC();
    
}

void init_spi1(void){
    
	//SPI1 (Master)
    
	//вывод SCK: выход двухтактный, альтернативна€ функци€, 50MHz
    
	GPIOA->CRL   |=  GPIO_CRL_MODE5;    //
    
	GPIOA->CRL   &= ~GPIO_CRL_CNF5;     //
    
	GPIOA->CRL   |=  GPIO_CRL_CNF5_1;   //
    
    
    
	//вывод MISO: вход цифровой с подт€гивающим резистором, подт€жка к плюсу
    
	GPIOA->CRL   &= ~GPIO_CRL_MODE6;    //
    
	GPIOA->CRL   &= ~GPIO_CRL_CNF6;     //
    
	GPIOA->CRL   |=  GPIO_CRL_CNF6_1;   //
    
	GPIOA->BSRR   =  GPIO_BSRR_BS6;     //
    
    
    
	//вывод MOSI: выход двухтактный, альтернативна€ функци€, 50MHz
    
	GPIOA->CRL   |=  GPIO_CRL_MODE7;    //
    
	GPIOA->CRL   &= ~GPIO_CRL_CNF7;     //
    
	GPIOA->CRL   |=  GPIO_CRL_CNF7_1;   //
    
    
    
	RCC->APB2ENR |= RCC_APB2ENR_SPI1EN; //подать тактирование                                      /
    
	SPI1->CR1     = 0x0000;             //очистить первый управл€ющий регистр
    
	SPI1->CR2     = 0x0000;             //очистить второй управл€ющий регистр
    
	SPI1->CR1    |= SPI_CR1_MSTR;       //контроллер должен быть мастером
    
    
    
	SPI1->CR1    &= ~SPI_CR1_BR;        //задаем скорость 24/2
    
	//SPI1->CR1    |= SPI_CR1_BR_0;				//
    
	//SPI1->CR1    |= SPI_CR1_BR_1;				//
    
	//SPI1->CR1    |= SPI_CR1_BR_2;
    
    
    
	SPI1->CR1    |= SPI_CR1_DFF;				//16 bit
    
	SPI1->CR1	 &= ~SPI_CR1_LSBFIRST;		//MSB first
    
	SPI1->CR1    |= SPI_CR1_SSI;        //обеспечить высокий уровень программного NSS
    
	SPI1->CR1    |= SPI_CR1_SSM;        //разрешить программное формирование NSS
    
	SPI1->CR1    |= SPI_CR1_SPE;        //разрешить работу модул€ SPI
    
}


void init_tim(void){
	RCC->APB1ENR |= RCC_APB1ENR_TIM3EN;
	TIM3->PSC  = 1;	 // 24/(1+1)MHz
	TIM3->ARR  = 4096;                                                              ;	 //overload every XX us
    
	TIM3->DIER = TIM_DIER_UIE;      //timer event en
	TIM3->CR1 |= TIM_CR1_ARPE; //reloaDon
	NVIC_SetPriority (TIM3_IRQn, 1);
	NVIC_EnableIRQ(TIM3_IRQn);
    
	TIM3->CR1 |= TIM_CR1_CEN;//—тарт счета
}



//===========================================


void TIM3_IRQHandler(void){
    
	if (TIM3->SR & TIM_SR_UIF){
        
		TIM3->SR &= ~TIM_SR_UIF;
        
		BLANK_1;	//BLANK HI
        
		if(latchData){
            
			XLAT_1;	//XLAT HI
            
			XLAT_0;	//XLAT LO
            
			latchData = 0;
            
		}
        
		BLANK_0;	//BLANK LO
        
        
		nextData=1;
        
        
        
	}
    
}



//===========================================

void init_TLC(void){
    
	VPRG_1;		//VPRG 	= 1
    
	DCPRG_0;	//DCPRG = 0
    
	BLANK_1;	//BLANK = 1
    
	XLAT_0;		//XLAT 	= 0
    
}

void set_DC(u16 *DC){
    
	DCPRG_1;	//DCPRG 	1
    
	VPRG_1;		//VPRG 		1
    
    
    
	while (!(SPI1->SR & SPI_SR_TXE));
    
	for(i=0;i<DCdata_N;i++){
        
		SPI1->DR = DCdataOut[i];
        
		while (!(SPI1->SR & SPI_SR_TXE));
        
	}
    
	XLAT_1;
    
	XLAT_0;
    
	VPRG_0;
}

void convertData(u8 *Din){
    
	u16 j = 0;
    
	u16 s = 1;
    
	u16 k = 0;
    
	u16 tmp1=0, tmp2=0;
    
    
    
	for(j=0;j<GSdata_N;j++){
        
		tmp1 =   Din[s];
        
		tmp1 <<= 4+(k*4);
        
		tmp2 =	 Din[s+1];
        
		tmp2 >>= 8-(k*4);
        
        
        
		GSdataOut[j] = tmp1+tmp2;
        
		s++; k++;
        
		if(k==3){
            
			k=0;
            
			s++;
            
		}
        
        
        
        
        
	}
    
}






